
; Registres PPI8255

PPI_PortA_H EQU #F4 ; RW
PPI_PortB_H EQU #F5 ; Read Only
PPI_PortC_H EQU #F6 ; Write Only
PPI_CTRL_H 	EQU #F7 ; Registre de controle. Write Only

PPI_PortA 	EQU #F400
PPI_PortB 	EQU #F500
PPI_PortC 	EQU #F600
PPI_CTRL 	EQU #F700

; GATE ARRAY
GA_PORT_H        EQU #7F
GA_PORT          EQU #7F00
GA_SELECT_COL    EQU #00
GA_SELECT_BORDER EQU #10 
GA_SET_COL       EQU #40


GA_BLUE 			EQU GA_SET_COL | #04
GA_BLACK 			EQU GA_SET_COL | #14
GA_BLUE_BRIGHT		EQU (GA_SET_COL | #15)
GA_RED 				EQU (GA_SET_COL | #1C)
GA_MAGENTA 			EQU GA_SET_COL | #18
GA_MAUVE			EQU GA_SET_COL | #1D
GA_RED_BRIGHT		EQU GA_SET_COL | #0C
GA_PURPLE			EQU GA_SET_COL | #05
GA_MAGENTA_BRIGHT 	EQU GA_SET_COL | #0D
GA_GREEN			EQU GA_SET_COL | #16
GA_CYAN				EQU GA_SET_COL | #06
GA_BLUE_SKY 		EQU GA_SET_COL | #17
GA_YELLOW 			EQU GA_SET_COL | #0E
GA_GREY				EQU GA_SET_COL | #00
GA_BLUE_PASTEL		EQU GA_SET_COL | #1F
GA_ORANGE 			EQU GA_SET_COL | #0E
GA_PINK				EQU GA_SET_COL | #07
GA_MAGENTA_PASTEL  	EQU GA_SET_COL | #0F
GA_GREEN_BRIGHT		EQU GA_SET_COL | #12
GA_GREEN_SEA		EQU GA_SET_COL | #02
GA_CYAN_BRIGHT		EQU GA_SET_COL | #13
GA_GREEN_LIME 		EQU GA_SET_COL | #1A
GA_GREEN_PASTEL		EQU GA_SET_COL | #19
GA_CYAN_PASTEL		EQU GA_SET_COL | #1B
GA_YELLOW_BRIGHT	EQU GA_SET_COL | #0A
GA_YELLOW_PASTEL	EQU GA_SET_COL | #03
GA_WHITE  			EQU GA_SET_COL | #0B


BIOS_RESET_AUDIO 	EQU #BCA7

; Desactive les interruptions
MACRO DISABLE_INT store
	DI 
	LD      HL,(#38) 
	LD      ({store}),HL 
	LD      HL,#c9fb	; EI + RET
	LD      (#38),HL 
	EI 
MEND

MACRO PUSH_MIRROR_REGS
	DI
	EXX
	PUSH HL
	PUSH BC
	PUSH DE
	EXX
	EX AF,AF'
	PUSH AF
	EX AF,AF'
	EI
MEND

MACRO POP_MIRROR_REGS
	DI
	EX AF,AF'
	POP AF
	EX AF,AF'	
	EXX
	POP DE
	POP BC
	POP HL
	EXX
	EI
MEND

; Attente synchro ecran
MACRO WAITSYNC 
	LD      b,PPI_PortB_H
@SYNC:
    IN      a,(C) 
	RRA 
	JP      nc,@SYNC 
MEND

; Recupere l'état des touches du clavier et joystick
MACRO GETKBSTATE DEST
	; TOUCHES DU CLAVIER
	LD      BC,PPI_PORTA |#0E 	; Selection registre 14 du PSG
	OUT     (C),C 
	LD      BC,PPI_PORTC |#C0  
	OUT     (C),C 		
	XOR     A 
	OUT     (C),A 	
	LD      BC,PPI_CTRL |#92 
	LD 		HL,{DEST}
	OUT     (C),C 		
	LD 		C,#40
	LD 		D,10
@KBGETLINE
	LD      B,PPI_PORTC_H  	   ; Selectionne ligne de clavier
	OUT     (C),C 
	LD      B,PPI_PORTA_H 
	IN      A,(C) 
	LD 		(HL),A
	INC 	HL		
	INC 	C				   ; Ligne suivante
	DEC 	D			  	   ; On s'arrete a 10
	JR 		NZ, @KBGETLINE	
	;On desactive
	LD      BC,PPI_CTRL |#82 
	OUT     (C),C 
	LD      BC,PPI_PORTC
	OUT     (C),C 
		
MEND

